#include <ultra64.h>
#include "sm64.h"
#include "behavior_data.h"
#include "model_ids.h"
#include "seq_ids.h"
#include "dialog_ids.h"
#include "segment_symbols.h"
#include "level_commands.h"

#include "game/level_update.h"

#include "levels/scripts.h"

#include "actors/common1.h"
#include "actors/group9.h"
#include "actors/group0.h"

#include "make_const_nonconst.h"
#include "levels/castle_courtyard/header.h"

const LevelScript level_castle_courtyard_entry[] = {
	INIT_LEVEL(),
	LOAD_MIO0(0x07, _castle_courtyard_segment_7SegmentRomStart, _castle_courtyard_segment_7SegmentRomEnd), 
	LOAD_MIO0(0x0A, _water_skybox_mio0SegmentRomStart, _water_skybox_mio0SegmentRomEnd), 
	LOAD_MIO0_TEXTURE(0x09, _outside_mio0SegmentRomStart, _outside_mio0SegmentRomEnd), 
	LOAD_MIO0(0x05, _group9_mio0SegmentRomStart, _group9_mio0SegmentRomEnd), 
	LOAD_RAW(0x0C, _group9_geoSegmentRomStart, _group9_geoSegmentRomEnd), 
	LOAD_MIO0(0x08, _common0_mio0SegmentRomStart, _common0_mio0SegmentRomEnd), 
	LOAD_RAW(0x0F, _common0_geoSegmentRomStart, _common0_geoSegmentRomEnd), 
	ALLOC_LEVEL_POOL(),
	MARIO(MODEL_MARIO, 0x00000001, bhvMario), 
	JUMP_LINK(script_func_global_1), 
	JUMP_LINK(script_func_global_10), 
	LOAD_MODEL_FROM_GEO(MODEL_COURTYARD_SPIKY_TREE, spiky_tree_geo), 
	LOAD_MODEL_FROM_GEO(MODEL_COURTYARD_WOODEN_DOOR, wooden_door_geo), 
	LOAD_MODEL_FROM_GEO(MODEL_LEVEL_GEOMETRY_03, castle_courtyard_geo_000200), 
	LOAD_MODEL_FROM_GEO(MODEL_VANILLA2, vanilla2_geo), 
	LOAD_MODEL_FROM_GEO(MODEL_MARK2, mark2_geo), 
	LOAD_MODEL_FROM_GEO(MODEL_KATALINA, katalina_geo), 
	LOAD_MODEL_FROM_GEO(MODEL_TAILS, tails_geo), 
	LOAD_MODEL_FROM_GEO(MODEL_WISP, wisp_geo), 
	LOAD_MODEL_FROM_GEO(MODEL_WISP2, wisp2_geo), 
	LOAD_MODEL_FROM_GEO(MODEL_CHAOHAPPY, chaohappy_geo), 
	LOAD_MODEL_FROM_GEO(MODEL_CHOCOLA, chocola_geo), 

	AREA(1, castle_courtyard_area_1),
		WARP_NODE(0x0A, LEVEL_CASTLE_COURTYARD, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		WARP_NODE(0xF0, LEVEL_CASTLE_COURTYARD, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		WARP_NODE(0xF1, LEVEL_CASTLE_COURTYARD, 0x01, 0x0A, WARP_NO_CHECKPOINT),
		WARP_NODE(0x1A, LEVEL_ENDING, 0x10, 0x0A, WARP_NO_CHECKPOINT),
		OBJECT(MODEL_CHAOHAPPY, 1942, 922, 1281, 0, -116, 0, DIALOG_040 << 24, bhvChaoHappy),
		OBJECT(MODEL_CHAOHAPPY, 2145, 657, -50, 0, -36, 0, DIALOG_040 << 24, bhvChaoHappy),
		OBJECT(MODEL_CHAOHAPPY, -904, -83, 556, 0, 111, 0, DIALOG_040 << 24, bhvChaoHappy),
		OBJECT(MODEL_CHOCOLA, 596, 30, -1595, 0, 0, 0, DIALOG_042 << 24, bhvChaoHappy),
		OBJECT(MODEL_KATALINA, 270, -30, -689, 0, 180, 0, DIALOG_044 << 16, bhvKattySit),
		OBJECT(MODEL_MARK2, 64, -5, -683, 0, -180, 0, DIALOG_045 << 16, bhvMarkSit),
		OBJECT(MODEL_TAILS, 1595, 162, 1316, 0, 64, 0, DIALOG_046 << 24, bhvToadMessageTails),
		OBJECT(MODEL_NONE, -27, 38, -1610, 0, 0, 0, 0x001A0000, bhvWarp),
		OBJECT(MODEL_VANILLA2, 342, 0, -1297, 0, 0, 0, DIALOG_043 << 24, bhvToadMessageVanillaHappy),
		OBJECT(MODEL_NONE, 1482, 280, 433, 0, 71, 0, 0x000A0000, bhvSpinAirborneWarp),
		OBJECT(MODEL_WISP, -792, -70, -884, 0, 75, 0, DIALOG_048 << 24, bhvWisp),
		OBJECT(MODEL_WISP2, -712, -83, -1156, 0, 63, 0, DIALOG_049 << 24, bhvWisp),
		TERRAIN(castle_courtyard_area_1_collision),
		MACRO_OBJECTS(castle_courtyard_area_1_macro_objs),
		SET_BACKGROUND_MUSIC(0x00, SEQ_STREAMED_ENDING),
		TERRAIN_TYPE(TERRAIN_GRASS),
	END_AREA(),

	FREE_LEVEL_POOL(),
	MARIO_POS(1, 0, 0, 0, 0),
	CALL(0, lvl_init_or_update),
	CALL_LOOP(1, lvl_init_or_update),
	CLEAR_LEVEL(),
	SLEEP_BEFORE_EXIT(1),
	EXIT(),
};
